#!/bin/bash
#===============================================================================
#
#          FILE:  process_email.sh
#
#         USAGE:  see --help
#
#   DESCRIPTION:  The script sends email using sendEmail program. It checks
#                 the /RouletteMaster/eml_outbox for any pending mail and sends 
#                 it with sendEmail. 
#       OPTIONS:  --help - prints usage
#  REQUIREMENTS:  sqlexec.sh, sendEmail - in path
#          BUGS:  ---
#         NOTES:  This script should be accessible run from /etc/cron.minutely
#        AUTHOR:  Enej Miklavcic, enej.miklavcic@gmail.com
#       COMPANY:  Freeware
#       VERSION:  1.0
#       CREATED:  28.4.2011
#      REVISION:  ---
#===============================================================================
SQL_EXE=/RouletteMaster/sqlexec.sh
OUTBOX=/RouletteMaster/eml_outbox/
CONF=/RouletteMaster/config/

mkdir -p $CONF
TMP_FILE=$CONF/cfg.email_from
if [ ! -e $TMP_FILE ]; then
    echo "roulettes@4knh.com" > $TMP_FILE
fi;

TMP_FILE=$CONF/cfg.email_smtp_host
if [ ! -e $TMP_FILE ]; then
    echo "mail.boss-g.com:587" > $TMP_FILE
fi;

TMP_FILE=$CONF/cfg.email_username
if [ ! -e $TMP_FILE ]; then
    echo "ruletas@boss-g.com" > $TMP_FILE
fi;

TMP_FILE=$CONF/cfg.email_password
if [ ! -e $TMP_FILE ]; then
    echo "sendinfo2011" > $TMP_FILE
fi;

instance_count=`ps -A|grep process_email |wc -l`;
if [ $instance_count -gt 2 ]; then # mora biti 2, ker '' nam naredijo se eno instanco
    echo "One Instance of processmail.sh is already running."
    exit 0;
fi


if [ ! -e $OUTBOX ]; then
    echo Can not find outbox at $OUTBOX
    exit -2
fi

if [ "--help" = "$1" ]  ;then
    echo
    echo "Usage:"
    echo TODO:
    echo
    exit 0;
fi

if [ $# -lt 0 ]; then
    echo "Params error. Try --help for help."
    exit 1
fi

#zapodimo se cez outbox in posljemo vsak mail
declare -a folders
folders=(`find $OUTBOX/* -maxdepth 0 -type d -name '* *' -o -type d -name '*' 2>/dev/null`)
arrSize=${#folders[@]} #array size of "folders"
let arrSize=$arrSize-1

#ali imamo kaj za poslati
if [ $arrSize -lt 0 ]; then
    echo Nothing to send.
    exit 0
fi

#posljemo vse kar je za poslati
for i in `seq 0 $arrSize`
 do
  if [ -d ${folders[$i]} ]
   then
    EMAIL=${folders[$i]}
#    echo $EMAIL
    DESTINATION_EMAIL=`cat $EMAIL/destination`
    EMAIL_SUBJECT=`cat $EMAIL/subject`
    if [ -e $EMAIL/sender ]; then
	SENDER_NAME=`cat $EMAIL/sender`
    else
	if [ -f /RouletteMaster/ROULETTE_NAME ]; then
	    SENDER_NAME=`cat /RouletteMaster/ROULETTE_NAME`
        else
	    SENDER_NAME=`echo "select RES_STR_VALUE from GET_PARAM('192.168.0.254', 'ROULETTE_NAME', 11)" | $SQL_EXE|head -8|tail -1|sed -e 's/  *$//'`
            echo $ROULETTE_NAME > /RouletteMaster/ROULETTE_NAME
        fi
    fi
    ATTACH=$EMAIL/eml_attach/
    
    echo -n "Sending email to $DESTINATION_EMAIL... "
    if [ -n "`cat $CONF/cfg.email_username`" ]; then
	cat $EMAIL/body | sendEmail  -f "$SENDER_NAME<`cat /RouletteMaster/config/cfg.email_from`>" -t $DESTINATION_EMAIL -s `cat $CONF/cfg.email_smtp_host` -u $EMAIL_SUBJECT -a `find $ATTACH/* 2>/dev/null` -xu `cat $CONF/cfg.email_username` -xp `cat $CONF/cfg.email_password`
    else
	cat $EMAIL/body | sendEmail  -f "$SENDER_NAME<`cat /RouletteMaster/config/cfg.email_from`>" -t $DESTINATION_EMAIL -s `cat $CONF/cfg.email_smtp_host` -u $EMAIL_SUBJECT -a `find $ATTACH/* 2>/dev/null`
    fi;

    if [ 0 -ne $? ]; then
	echo " Sending Failed."
	RESULT=-1
    else
	rm $EMAIL -rf
        echo " Sent!"
        RESULT=0
	exit 0; #posljemo samo 1 email na minuto, da ne obremenjujemo smtp streznika zaradi spam filtrov
    fi;

  fi
done
exit $RESULT
